Attribute VB_Name = "Module1"
Option Explicit

'declare some constant values for calculating

Public Const PI As Double = 3.14159265358979
Public Const EPSLN As Double = 0.0000000001
Public Const S2R As Double = 4.84813681109536E-06 'sin(1")
Public Const OK As Integer = 0
Public Const ERROR As Integer = -1
Public Const IN_BREAK As Integer = -2

'declare information about some ellipsoids
         
Public major(1)  As Double
Public minor(1) As Double

'Public Const Bessel_r_major As Double = 6377397.155   'major axis of Bessel1841
'Public Const Bessel_r_minor As Double = 6356078.96325 'minor axis of Bessel1841
'Public Const Wgs84_r_major As Double = 6378137#  'major axis of WGS84
'Public Const Wgs84_r_minor As Double = 6356752.3142 ' minor axis of WGS84

'declare constant values for datum transformation between Wgs84 and Bessel1841
'datum shift values from Korean Agency for Defense Development(ADD) technical reports are as follows

'Public Const dX_B2W As Single = -105.627
'Public Const dY_B2W As Single = 462.37
'Public Const dZ_B2W As Single = 643.258


'datum shift values from NIMA of USA are as follows : Which one is more correct? I don't know.
'It will slightly different!!  Aha..
'Public Const dX_B2W As Single = -128
'Public Const dY_B2W As Single = 481
'Public Const dZ_B2W As Single = 664

Public Const dX_W2B As Single = 128
Public Const dY_W2B As Single = -481
Public Const dZ_W2B As Single = -664

'declare information about TM and UTM projections in Korea.
'Attention : UTM uses exactly the same method as TM uses. That's right!
    
 Public SF(1 To 6), LonCen(1 To 6), LatCen(1 To 6), FN(1 To 6), FE(1 To 6) As Double
   
'Public Const TM_scale_factor As Double = 1#  'scale reduction factor
'Public Const TM_scale_factorK As Double = 0.9999 'scale reduction factor of Katec system
'Public Const UTM_scale_factor As Double = 0.9996 'scale reduction factor of UTM(Universal Tranverse Mercator) System

'Public Const TM_lon_center1 As Double = 2.18171200985643 'center longitude (projection center) of Korea Zone I in radian 125:00:10.405
'Public Const TM_lon_center2 As Double = 2.21661859489632 'center longitude (projection center) of Korea Zone II in radian 127:00:10.405
'Public Const TM_lon_center3 As Double = 2.2515251799362  'center longitude (projection center) of Korea Zone III in radian 129:00:10.405
'Public Const TM_lon_centerK As Double = 2.23402144255274 'center longitude (projection center) of so called Katec systems in radian 128:00:00
'Public Const UTM_lon_center51 As Double = 2.14675497995303 'center longitude of UTM zone 51 in radian 123:00:00
'Public Const UTM_lon_center52 As Double = 2.25147473507269 'center longitue of UTM zone 52 in radian 129:00:00

'Public Const TM_lat_origin As Double = 0.663225115757845 'center latitude of Korea in radian 38:00:00
'Public Const UTM_lat_origin As Double = 0 'center latitude of UTM, as is equator

'Public Const TM_false_northing As Double = 500000 'y offset in meters
'Public Const TM_false_easting As Double = 200000 'x offset in meters
'Public Const TM_false_northingK As Double = 600000 'y offset of Katec systems in meters
'Public Const TM_false_eastingK As Double = 400000 'x offset of Katec systems in meters
'Public Const UTM_false_northing As Double = 0 'y offest in meters for UTM of northern hemisphere
'Public Const UTM_false_easting As Double = 500000 'x offset in meters for UTM

Public Function Cube(x As Double) As Double
    
    Cube = x * x * x
    
End Function

Public Function Quad(x As Double) As Double

    Quad = x * x * x * x
        
End Function

Public Function Gmax(a, b)

    If a >= b Then
        Gmax = a
    Else
        Gmax = b
    End If
            
End Function

Public Function Gmin(a, b)

    If a <= b Then
        Gmin = a
    Else
        Gmin = b
    End If
    
End Function

' Functions to compute the constants e0, e1, e2, and e3 which are used
' in a series for calculating the distance along a meridian.  The
' input x represents the eccentricity squared.

Public Function e0fn(x As Double) As Double

    e0fn = 1# - 0.25 * x * (1# + x / 16# * (3# + 1.25 * x))

End Function

Public Function e1fn(x As Double) As Double
    
    e1fn = 0.375 * x * (1# + 0.25 * x * (1# + 0.46875 * x))
    
End Function

Public Function e2fn(x As Double) As Double

    e2fn = 0.05859375 * x * x * (1# + 0.75 * x)
    
End Function

Public Function e3fn(x As Double) As Double

    e3fn = x * x * x * (35# / 3072#)
    
End Function

' Function to compute the constant e4 from the input of the eccentricity
' of the spheroid, x.  This constant is used in the Polar Stereographic
' projection.

Public Function e4fn(x As Double) As Double

Dim con As Double
Dim com As Double

    con = 1# + x
    com = 1# - x
    e4fn = Sqr((con ^ con) * (com ^ com))
    
End Function

' Function computes the value of M which is the distance along a meridian
' from the Equator to latitude phi.

Public Function mlfn(e0 As Double, e1 As Double, e2 As Double, e3 As Double, phi As Double) As Double

    mlfn = e0 * phi - e1 * Sin(2# * phi) + e2 * Sin(4# * phi) - e3 * Sin(6# * phi)

End Function

'Function to simplify the ArcCosine calculation

Public Function acos(x As Double) As Double
    
    acos = Atn(-x / Sqr(-x * x + 1)) + 2 * Atn(1)
    
End Function

'Function to simplify the ArcSine calculation

Public Function asin(x As Double) As Double

    asin = Atn(x / Sqr(-x * x + 1))
    
End Function

'To eliminate some problem

Public Function asinz(con As Double) As Double

    If Abs(con) > 1# Then
        If con > 1# Then
            con = 1#
        Else
            con = -1#
        End If
    End If
    
    asinz = asin(con)
    
End Function

'Function for converting degree to dms(degree:minute:second)

Public Sub d2dms(ByRef Lon As Double, ByRef Lat As Double, ByRef LonMin As Integer, ByRef LonSec As Double, ByRef LatMin As Integer, ByRef LatSec As Double)

Dim deltaLon, deltaLat As Double

    deltaLon = Lon - Int(Lon)
    deltaLat = Lat - Int(Lat)
    
    LonMin = Int(deltaLon * 60)
    LatMin = Int(deltaLat * 60)

    LonSec = (deltaLon * 60 - LonMin) * 60
    LatSec = (deltaLat * 60 - LatMin) * 60
    
    If Format(LonSec, "0.00000") >= 60 Then
        LonSec = LonSec - 60
        LonMin = LonMin + 1
        
        If LonMin >= 60 Then
            LonMin = LonMin - 60
            Lon = Int(Lon) + 1
        Else
            Lon = Int(Lon)
        End If
    
    Else
        Lon = Int(Lon)
    End If
    
    If Format(LatSec, "0.00000") >= 60 Then
        LatSec = LatSec - 60
        LatMin = LatMin + 1
        
        If LatMin >= 60 Then
            LatMin = LatMin - 60
            Lat = Int(Lat) + 1
        Else
            Lat = Int(Lat)
        End If
    
    Else
        Lat = Int(Lat)
    End If

End Sub

'Molodensky Datum Transformation function for general datum transformation.
'Coded by Shin, Sanghee(endofcap@geo.giri.co.kr) 24th Feb, 1999
'Reference manual : DEFENSE MAPPING AGENCY TECHNICAL MANUAL 8358.1
'You can read above manual in this home page. http://164.214.2.59/GandG/tm83581/toc.htm

Public Sub DatumTrans(ByVal input_a As Double, ByVal input_b As Double, _
input_Phi As Double, input_Lamda As Double, input_H As Double, _
ByVal output_a As Double, ByVal output_b As Double, ByRef output_Phi As Double, ByRef output_Lamda As Double, ByRef output_H As Double, delta_X As Single, delta_Y As Single, delta_Z As Single)

Dim delta_a, delta_f, delta_Phi, delta_Lamda, delta_H As Double 'differeces between input ellipsoid and output ellipsoid like major axis and flattening. As is ouput - input
Dim Rm, Rn As Double 'radius of curvature in the meridian and radius of curvature in the prime vertical
Dim temp, es_temp, f As Double


temp = input_b / input_a
f = 1 - temp 'flattening
es_temp = 1# - temp * temp 'e2

delta_a = output_a - input_a 'output major axis - input major axis
delta_f = input_b / input_a - output_b / output_a 'Output Flattening - input flattening

Rm = (input_a * (1 - es_temp)) / ((1 - es_temp * Sin(input_Phi) * Sin(input_Phi)) ^ (3 / 2))
Rn = input_a / ((1 - es_temp * Sin(input_Phi) * Sin(input_Phi)) ^ (1 / 2))

delta_Phi = ((((-delta_X * Sin(input_Phi) * Cos(input_Lamda) - delta_Y * Sin(input_Phi) * Sin(input_Lamda)) + delta_Z * Cos(input_Phi)) + delta_a * Rn * es_temp * Sin(input_Phi) * Cos(input_Phi) / input_a) + delta_f * (Rm / temp + Rn * temp) * Sin(input_Phi) * Cos(input_Phi)) / (Rm + input_H)
delta_Lamda = (-delta_X * Sin(input_Lamda) + delta_Y * Cos(input_Lamda)) / ((Rn + input_H) * Cos(input_Phi))
delta_H = delta_X * Cos(input_Phi) * Cos(input_Lamda) + delta_Y * Cos(input_Phi) * Sin(input_Lamda) + delta_Z * Sin(input_Phi) - delta_a * input_a / Rn + delta_f * temp * Rn * Sin(input_Phi) * Sin(input_Phi)

output_Phi = input_Phi + delta_Phi
output_Lamda = input_Lamda + delta_Lamda
output_H = input_H + delta_H

End Sub
